// AdvDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Grab.h"
#include "AdvDlg.h"
#include "procs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAdvDlg dialog


CAdvDlg::CAdvDlg(CWnd* pParent /*=NULL*/)
	: CTipsDlg(CAdvDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAdvDlg)
	m_filemask = _T("");
	m_headers = _T("");
	m_alternative = FALSE;
	m_url2 = _T("");
	m_maxsockets = 0;
	m_retries = 0;
	m_timeout_c = 0;
	m_timeout_r = 0;
	m_timeout_s = 0;
	m_mintile = 0;
	m_minxy = 0;
	m_skipexist = FALSE;
	m_tooltips = FALSE;
	m_replace11 = _T("");
	m_replace12 = _T("");
	m_replace21 = _T("");
	m_replace22 = _T("");
	m_proxy = _T("");
	m_useproxy = FALSE;
	m_random = FALSE;
	//}}AFX_DATA_INIT
}


void CAdvDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAdvDlg)
	DDX_Control(pDX, IDC_PROXY, m_o_proxy);
	DDX_Control(pDX, IDC_REPLACE22, m_o_replace22);
	DDX_Control(pDX, IDC_REPLACE21, m_o_replace21);
	DDX_Control(pDX, IDC_REPLACE12, m_o_replace12);
	DDX_Control(pDX, IDC_REPLACE11, m_o_replace11);
	DDX_Control(pDX, IDC_O_MAXSOCKETS, m_o_maxsockets);
	DDX_Control(pDX, IDC_URL2, m_o_url2);
	DDX_Text(pDX, IDC_FILEMASK, m_filemask);
	DDX_Text(pDX, IDC_HEADERS, m_headers);
	DDX_Check(pDX, IDC_ALTERNATIVE, m_alternative);
	DDX_Text(pDX, IDC_URL2, m_url2);
	DDX_Text(pDX, IDC_MAXSOCKETS, m_maxsockets);
	DDX_Text(pDX, IDC_RETRIES, m_retries);
	DDX_Text(pDX, IDC_TIMEOUT_C, m_timeout_c);
	DDX_Text(pDX, IDC_TIMEOUT_R, m_timeout_r);
	DDX_Text(pDX, IDC_TIMEOUT_S, m_timeout_s);
	DDX_Text(pDX, IDC_MINTILE, m_mintile);
	DDV_MinMaxInt(pDX, m_mintile, 0, 20);
	DDX_Text(pDX, IDC_MINXY, m_minxy);
	DDV_MinMaxInt(pDX, m_minxy, 0, 20);
	DDX_Check(pDX, IDC_SKIPEXIST, m_skipexist);
	DDX_Check(pDX, IDC_TOOLTIPS, m_tooltips);
	DDX_Text(pDX, IDC_REPLACE11, m_replace11);
	DDX_Text(pDX, IDC_REPLACE12, m_replace12);
	DDX_Text(pDX, IDC_REPLACE21, m_replace21);
	DDX_Text(pDX, IDC_REPLACE22, m_replace22);
	DDX_Text(pDX, IDC_PROXY, m_proxy);
	DDX_Check(pDX, IDC_USEPROXY, m_useproxy);
	DDX_Check(pDX, IDC_RANDOM, m_random);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAdvDlg, CTipsDlg)
	//{{AFX_MSG_MAP(CAdvDlg)
	ON_BN_CLICKED(IDC_ALTERNATIVE, OnAlternative)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_NS4, OnNs4)
	ON_BN_CLICKED(IDC_IE4, OnIe4)
	ON_BN_CLICKED(IDC_TOOLTIPS, OnTooltips)
	ON_BN_CLICKED(IDC_USEPROXY, OnUseproxy)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdvDlg message handlers

BOOL CAdvDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_o_maxsockets.SetRange(1, 32);
	m_o_maxsockets.SetPos(m_maxsockets);
	m_o_maxsockets.SetTicFreq(4);
	UpdateControls();
	EnableToolTips(m_tooltips);
	return true;
}

void CAdvDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	UpdateData(CTRL2VAR);
	m_maxsockets = m_o_maxsockets.GetPos();
	UpdateData(VAR2CTRL);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CAdvDlg::OnNs4() 
{
	m_headers.LoadString(IDS_NS4);
	UpdateData(VAR2CTRL);
}

void CAdvDlg::OnIe4() 
{
	m_headers.LoadString(IDS_IE4);
	UpdateData(VAR2CTRL);
}

void CAdvDlg::OnAlternative() 
{
	UpdateData(CTRL2VAR);
	UpdateControls();
}

void CAdvDlg::UpdateControls()
{
	m_o_url2.EnableWindow(m_alternative);
	m_o_replace11.EnableWindow(m_alternative);
	m_o_replace12.EnableWindow(m_alternative);
	m_o_replace21.EnableWindow(m_alternative);
	m_o_replace22.EnableWindow(m_alternative);
	m_o_proxy.EnableWindow(m_useproxy);
}

void CAdvDlg::OnTooltips() 
{
	UpdateData(CTRL2VAR);
	EnableToolTips(m_tooltips);
}

void CAdvDlg::OnUseproxy() 
{
	UpdateData(CTRL2VAR);
	UpdateControls();
}
