// Download.h: interface for the CDownload class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DOWNLOAD_H__7593F0D3_E552_11D3_9139_204C4F4F5020__INCLUDED_)
#define AFX_DOWNLOAD_H__7593F0D3_E552_11D3_9139_204C4F4F5020__INCLUDED_

#include <afxtempl.h>
#include <afxinet.h>

#include "html.h"

#define METHOD_NONE 0
#define METHOD_GET 1
#define METHOD_POST 2

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

typedef struct {CString name; CString value;} Tvariable;

typedef CList<Tvariable, Tvariable> Tvarlist;

class CDownloadCallback : private CHtmlCallback
{
public:
	virtual BOOL DownloadProgress(int size, int total) = 0;
	virtual	void ProcessHTML(CString tag, CString par, CString value) {};
};

class CDownloadInfo
{
public:
	void SetOptions(int method, CString headers, CString filename, CString path);
	void SetMethod(int method);
	bool SetURL(CString url);
	CDownloadInfo();
	~CDownloadInfo();
	CDownloadInfo( const CDownloadInfo &s); //copy contructor
	CDownloadInfo& operator=( const CDownloadInfo &s); // assignment
	CString server, object, headers, path, filename;
	unsigned short port;
	int method;
	bool parseHTMLonly;
	Tvarlist variables;
};

class CDownload : public CObject, private CHtmlCallback
{
	DECLARE_DYNCREATE(CDownload)
public:
	CDownload(CDownloadCallback* callback = NULL);
	virtual ~CDownload();
	BOOL OpenSession(CString proxy="", int retries = 0, int timeout_c = 0,
		int timeout_r = 0, int timeout_s = 0);
	void CloseSession();
	int Start(CDownloadInfo* info);
	CString GetError();
protected:
	int retries;
	void ProcessHTML(CString tag, CString par, CString value);
	BOOL OpenConnection(CDownloadInfo* info);
	void CloseConnection();
	CString last_server, errormsg;
	CHttpConnection* connection;
	CInternetSession* session;
	CDownloadCallback* callback;
};

#endif // !defined(AFX_DOWNLOAD_H__7593F0D3_E552_11D3_9139_204C4F4F5020__INCLUDED_)
