// GrabDlg.h : header file
//

#if !defined(AFX_GRABDLG_H__0E22DCA8_E54A_11D3_9139_204C4F4F5020__INCLUDED_)
#define AFX_GRABDLG_H__0E22DCA8_E54A_11D3_9139_204C4F4F5020__INCLUDED_

#include <afxtempl.h>

#include "Worker.h"
#include "TipsDlg.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define PARAMDEF() CParam* param = (CParam*)_param;

class CParam : public CWorkerUserData
{
public:
	CString alternative_url, alternative_mask, alternative_base;
	void SetState(unsigned char state);
	int number;
	CStatic* status;
	CProgressCtrl* progress;
	unsigned char *stateref;
	unsigned char state;
	unsigned __int64 ms1970;
	CDownloadInfo original_info;
	UINT tile_y;
	UINT tile_x;
};

/////////////////////////////////////////////////////////////////////////////
// CGrabDlg dialog

class CGrabDlg : public CTipsDlg, private CWorkerCallback
{
DECLARE_SERIAL(CGrabDlg)
// Construction
public:
	BOOL m_useproxy;
	CString m_proxy;
	BOOL m_alternative;
	CString m_url2;
	CGrabDlg(CWnd* pParent = NULL);	// standard constructor
// CWorker messages - CWorkerCallback overrides
	int  WorkerNext(CWorkerUserData* _param);
	void WorkerStatus(CWorkerUserData* _param, CString text);
	void WorkerTransfer(CWorkerUserData* _param, int size, int total);
	void WorkerDone(CWorkerUserData* _param);
	void WorkerError(CWorkerUserData* _param, CString text);
	void WorkerProcessHTML(CWorkerUserData* _param, CString tag, CString par, CString value);
// Dialog Data
	CString m_headers;
	//{{AFX_DATA(CGrabDlg)
	enum { IDD = IDD_GRAB_DIALOG };
	CStatic	m_table;
	CButton	m_o_load;
	CButton	m_o_save;
	CButton	m_o_advanced;
	CEdit	m_o_name;
	CEdit	m_o_value;
	CButton	m_delete;
	CButton	m_insert;
	CButton	m_update;
	CButton	m_o_method0;
	CButton	m_o_method1;
	CButton	m_o_method2;
	CListCtrl	m_varlist;
	CButton	m_abort;
	CEdit	m_o_y2;
	CEdit	m_o_y1;
	CEdit	m_o_x2;
	CEdit	m_o_x1;
	CEdit	m_o_url;
	CEdit	m_o_stepy;
	CEdit	m_o_stepx;
	CEdit	m_o_path;
	CEdit	m_o_edit1;
	CButton	m_grab;
	CStatic	m_o_status4;
	CStatic	m_o_status3;
	CStatic	m_o_status2;
	CStatic	m_o_status1;
	CStatic	m_o_status0;
	CProgressCtrl	m_progress4;
	CProgressCtrl	m_progress3;
	CProgressCtrl	m_progress2;
	CProgressCtrl	m_progress0;
	CProgressCtrl	m_progress1;
	CProgressCtrl	m_progress;
	CString	m_url;
	CString	m_path;
	int	m_x1;
	int	m_x2;
	int	m_y1;
	int	m_y2;
	int	m_stepx;
	int	m_stepy;
	int		m_method;
	CString	m_name;
	CString	m_value;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGrabDlg)
	public:
	virtual void Serialize(CArchive& ar);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	BOOL m_random;
	void PaintTable();
	CString m_replace11, m_replace12, m_replace21, m_replace22;
	int m_minxy, m_mintile, m_skipexist, m_tooltips;
	void SaveRegistry();
	void LoadRegistry();
	int m_maxsockets;
	CString m_filemask;
	unsigned __int64 New_ms1970();
	unsigned __int64 last_ms1970;
	void OnCancel();
	int	m_retries, m_timeout_c, m_timeout_r, m_timeout_s;
	BOOL enabled;
	BOOL kill_order_given;
// CWorker Window Messages
	long WorkerTerminated(unsigned int,long);
	CCriticalSection *HandlingCall, *HandlingMessage;
// Variable List
	int list_focus;
	void AddVariable(CString name, CString value);
	Tvariable CGrabDlg::NextVariable(int &i);
	static int CALLBACK CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
// Thread control
	void KillThreads();
// Visual interface
	void Status(CStatic* status, CString text);
	void Progress(CProgressCtrl* progress, int size = 0, int total = 0);
	void EnableControls(BOOL enabled);
	CRect table_area;
	CDC table_buffer;
	CBitmap table_bitmap;
	CBitmap *table_pOldBitmap;
	void GetItemRect(CWnd *wnd, CRect *areaRect);
// Download control
	void SetToDone(CParam* param);
	void ReplaceVariables(CString* source, CParam* param,  BOOL encoded = false);
	CString ReplaceVariables(CString source, CParam* param,  BOOL encoded = false);
	void ReplaceInInfo(CParam* param, CDownloadInfo& infoX);
	unsigned char state[MAXCOORD][MAXCOORD];
	int donecnt;
	int coord_x, coord_y;
// Multithreading objects
	CTypedPtrList<CObList, CWorker*> workers;
// System
	HICON m_hIcon;
	#if _DEBUG 
	CMemoryState mem_old, mem_cur, mem_dif;
	#endif
	// Generated message map functions
	//{{AFX_MSG(CGrabDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnGrab();
	afx_msg void OnDestroy();
	afx_msg void OnAbort();
	afx_msg void OnMethod();
	afx_msg void OnColumnclickVariables(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	afx_msg void OnItemchangedVariables(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnUpdate();
	afx_msg void OnInsert();
	afx_msg void OnDelete();
	afx_msg void OnChangeName();
	afx_msg void OnChangeValue();
	afx_msg void OnAdvanced();
	afx_msg void OnSave();
	afx_msg void OnLoad();
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GRABDLG_H__0E22DCA8_E54A_11D3_9139_204C4F4F5020__INCLUDED_)
