// Html.cpp: implementation of the CHtml class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Grab.h"
#include "Html.h"
#include "Procs.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNCREATE(CHtml, CObject)

CHtml::CHtml()
{
	Reset();
}

CHtml::~CHtml()
{

}

void CHtml::Reset()
{
	mode = TAG_SEARCH;
	tag = "";
	par = "";
	value = "";
}

void CHtml::ParseChar(char ch)
{
	switch( mode ) 
	{
	case TAG_SEARCH: // Looking for tag
		if (ch == '<') {
			mode = TAG_READ;
			tag = "";
		}
		break;
    case TAG_READ: // Reading tag
        if (ch == ' ') {
			mode = PAR_SEARCH;
	        break;
		}
        if (ch == '!') {
			mode = COMMENT_SEARCH;
	        break;
		}
		if (ch == '>') {
			mode = TAG_SEARCH;
			break;
		}
		tag = tag + Upcase(ch);
		break;
	case PAR_SEARCH : // Looking for par
		if (ch == '>') {
			mode = TAG_SEARCH;
	        break;
		}
		if (ch != ' ') {
			mode = PAR_READ;
			par = Upcase(ch);
	        break;
		}
        break;
    case PAR_READ : //Reading par
        if (ch == '=') {
			mode = VALUE_READ;
			value = "";
	        break;
		}
        if (ch == ' ') {
			mode = PAR_SEARCH;
	        break;
		}
		if (ch == '>') {
			mode = TAG_SEARCH;
	        break;
		}
		par = par + Upcase(ch);
        break;
    case VALUE_READ : //Reading value
		if ((ch == ' ')||(ch == '>')) { // end of value
			callback->ProcessHTML(tag, par, value);
			if (ch == ' ') mode = PAR_SEARCH;
			else mode = TAG_SEARCH;
			break;
		}
		if (ch == '"') {
			mode = VALUE_READ_PARANTH;
			break;
		}
		value = value + ch;
		break;
    case VALUE_READ_PARANTH : //Reading value in '"'
		if (ch == '"') { // end of value
			mode = PAR_SEARCH;
			callback->ProcessHTML(tag, par, value);
			break;
		}
		value = value + ch;
        break;
    case COMMENT_SKIP1 : //Skipping comment - looking for 1st "-"
		if (ch == '-') mode = COMMENT_SKIP2;
        break;
    case COMMENT_SKIP2 : //Skipping comment - looking for 2nd "-"
		if (ch == '-') {
			mode = COMMENT_SKIP3;
            break;
		}
		mode = COMMENT_SKIP1;
        break;
    case COMMENT_SKIP3 : //Skipping comment - looking for ">"
		if (ch == '>') {
			mode = TAG_SEARCH;
            break;
		}
		mode = COMMENT_SKIP1;
		break;
	case COMMENT_SEARCH : //Beginning comment - looking for "-"
		if (ch == '-') {
			mode = COMMENT_SKIP1;
            break;
		}
		mode = PAR_SEARCH;
        break;
	}
}

void CHtml::ParseBuffer(char buffer[], int size, CHtmlCallback* callback)
{
	this->callback = callback;
	char* endptr = buffer + size;
	for (char* ptr = buffer; ptr<endptr; ptr++) ParseChar(*ptr);
}

CString CHtml::AbsoluteLink(CString link, CString base)
{
	int i,pos,pos2,pos3;
	CString temp;
	pos2 = base.GetLength();
	for (i=0;i<base.GetLength();i++) {
		if (base[i] == '/') {
			pos2 = i;
		}
		if (base[i] == '.') {
			pos3 = i;
		}
	}
	if ((pos3 < pos2)&&(base.Right(1) != '/')) {
		base = base+'/';
	}
	
	temp = link;
	pos = temp.Find("mailto:");
	if (pos != -1) {return "";}
	pos = temp.Find("javascript:");
	if (pos != -1) {return "";}
	pos = temp.Find("gopher:");
	if (pos != -1) {return "";}
	pos = temp.Find("://");
	if (pos == -1) {
		if (temp[0] == '/') { // jump to root
			pos = -1;
			for (int i=0;i<base.GetLength();i++) {
				if ((base[i] == '/')&&(base[i-1] != ':')
					&&(base[i-2] != ':')&&(pos == -1)) {
					pos = i-1;
				}
			}
			if (pos == -1) {
				pos = base.GetLength();
			}
		}
		else {
			// search for last '/'
			pos = -1;
			for (int i=0;i<base.GetLength();i++) {
				if ((base[i] == '/')&&(base[i-1] != ':')
					&&(base[i-2] != ':')) {
					pos = i;
				}
			}
			if (pos == -1) {
				pos = base.GetLength();
				if (temp[0] != '/') {
					temp = '/'+temp;
				}
			}
		}
		temp = base.Left(pos+1)+temp;
	}
	pos = -1;
	for (i=0;i<temp.GetLength();i++) {
		if (temp.Mid(i,3) == "/..") {
			temp = temp.Left(pos+1)+temp.Right(temp.GetLength()-i-4);
		}
		if (temp[i] == '/') {
			pos = i;
		}
	}
	return temp;
}
