// Worker.cpp : implementation file
//

#include "stdafx.h"
#include "Grab.h"
#include "Worker.h"
#include "Download.h"
#include "Procs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWorker

IMPLEMENT_DYNCREATE(CWorker, CWinThread)

CWorker::CWorker()
{
	m_bAutoDelete = false;
	owner = NULL;
	param = NULL;
	event_kill = new CEvent(false, true);
	event_kill->ResetEvent();
	terminating	= false;
}

CWorker::~CWorker()
{
	delete event_kill;
}

BOOL CWorker::InitInstance()
{
	// TODO:  perform and per-thread initialization here
	return TRUE;
}

BEGIN_MESSAGE_MAP(CWorker, CWinThread)
	//{{AFX_MSG_MAP(CWorker)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWorker message handlers

void CWorker::SetParam(CWorkerUserData* param) {
	this->param = param;
}

CWorkerUserData* CWorker::GetParam() {
	return param;
}

void CWorker::ProcessHTML(CString tag, CString par, CString value) {
	owner->WorkerProcessHTML(param, tag, par, value);
}

BOOL CWorker::DownloadProgress(int size, int total)
{
	CSingleLock wait_for_kill(event_kill);
	if (!wait_for_kill.Lock(0))
	{		
		if (size==0) {
			owner->WorkerStatus(param, "Sending request ..");
		}
		else {
			owner->WorkerStatus(param, "Downloading ..");
		}
		owner->WorkerTransfer(param, size, total);
		return true; // Continue downloading
	}
	else {
		return false; // Abort downloading
	}
}

int CWorker::Run() 
{
	if (owner == NULL) return 0;

	bool error = false;
	int code;
	CString errormsg;
	
	owner->WorkerStatus(param, "Connecting to server ..");
	
	CDownload download(this);
	if (download.OpenSession(param->proxy, param->retries, param->timeout_c,
			param->timeout_r, param->timeout_s)==0) {
		while (true) {
			code = owner->WorkerNext(param);
			if (code==1) break; // no more
			if (code==2) { // no link = error
				error = true;
				errormsg = "Can't find suitable link in a page\n"+param->info.object;
				break;
			}
			code = download.Start(&param->info);
			if (code!=0) {
				error = true;
				errormsg = download.GetError();
				break;
			}
			owner->WorkerDone(param);
		}
	}
	else {
		error = true;
	}

	download.CloseSession();

	if (error) {
		owner->WorkerError(param, errormsg);
		if (code==2)
			owner->WorkerStatus(param, "Aborted.");
		else
			owner->WorkerStatus(param, "Error.");
	}
	else
		owner->WorkerStatus(param, "Done.");

	terminating	= true;
	m_pMainWnd->PostMessage(WM_USER_TERMINATED);

	return 0;
}

BOOL CWorker::Terminating()
{
	return terminating;
}

void CWorker::KillOrder()
{
	event_kill->SetEvent();
	SetThreadPriority(THREAD_PRIORITY_ABOVE_NORMAL);
}
