// Worker.h : header file
//

#if !defined(AFX_WORKER_H__6F1463E2_EC2D_11D3_9150_204C4F4F5020__INCLUDED_)
#define AFX_WORKER_H__6F1463E2_EC2D_11D3_9150_204C4F4F5020__INCLUDED_

#include <afxmt.h>
#include "download.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CWorkerUserData
{
public:
	CDownloadInfo info;
	int retries, timeout_c, timeout_r, timeout_s;
	CString proxy;
};

class CWorkerCallback
{
public:
	virtual int  WorkerNext(CWorkerUserData* param) = 0;
	virtual void WorkerStatus(CWorkerUserData* param, CString text) = 0;
	virtual void WorkerTransfer(CWorkerUserData* param, int size, int total) = 0;
	virtual void WorkerDone(CWorkerUserData* param) = 0;
	virtual void WorkerError(CWorkerUserData* param, CString text) = 0;
	virtual	void WorkerProcessHTML(CWorkerUserData* param, CString tag, CString par, CString value) = 0;
};

/////////////////////////////////////////////////////////////////////////////
// CWorker thread

class CWorker : public CWinThread, private CDownloadCallback
{
	DECLARE_DYNCREATE(CWorker)
public:
	CWorker();
	~CWorker();
	void SetOwner(CWorkerCallback* pOwner) { owner = pOwner;};
	void SetParam(CWorkerUserData* param);
	CWorkerUserData* GetParam();
	BOOL Terminating();
	void KillOrder();
	virtual BOOL DownloadProgress(int size, int total);

protected:
	void ProcessHTML(CString tag, CString par, CString value);
	CWorkerCallback* owner;
	CWorkerUserData* param;
	BOOL terminating;
	CEvent *event_kill;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWorker)
	public:
	virtual BOOL InitInstance();
	virtual int Run();
	//}}AFX_VIRTUAL

	// Generated message map functions
	//{{AFX_MSG(CWorker)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WORKER_H__6F1463E2_EC2D_11D3_9150_204C4F4F5020__INCLUDED_)
